System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, __checkObsolete__, __checkObsoleteInNamespace__, _decorator, Camera, Component, ERaycast2DType, Input, input, Node, PhysicsSystem2D, v3, _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _class3, _crd, ccclass, property, PhysicsController;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'transform-class-properties is enabled and runs after the decorators transform.'); }

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
      __checkObsolete__ = _cc.__checkObsolete__;
      __checkObsoleteInNamespace__ = _cc.__checkObsoleteInNamespace__;
      _decorator = _cc._decorator;
      Camera = _cc.Camera;
      Component = _cc.Component;
      ERaycast2DType = _cc.ERaycast2DType;
      Input = _cc.Input;
      input = _cc.input;
      Node = _cc.Node;
      PhysicsSystem2D = _cc.PhysicsSystem2D;
      v3 = _cc.v3;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "eb558+TKpdLi5a+lTWyzVt1", "PhysicsController", undefined);

      __checkObsolete__(['_decorator', 'Camera', 'Component', 'ERaycast2DType', 'EventTouch', 'Input', 'input', 'Node', 'PhysicsSystem2D', 'v3', 'Vec3']);

      ({
        ccclass,
        property
      } = _decorator);

      _export("PhysicsController", PhysicsController = (_dec = ccclass('PhysicsController'), _dec2 = property(Node), _dec3 = property(Camera), _dec(_class = (_class2 = (_class3 = class PhysicsController extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "enemyNode", _descriptor, this);

          _initializerDefineProperty(this, "mainCamera", _descriptor2, this);
        }

        start() {
          this.registerEvent();
        }

        registerEvent() {
          input.on(Input.EventType.TOUCH_START, this.onTouchStart, this);
        }

        onTouchStart(event) {
          let position = event.getLocation();
          let worldPosition = v3();
          console.log(this.mainCamera.camera.screenToWorld(worldPosition, v3(position.x, position.y)));
          console.log(this.enemyNode.worldPosition);
          let result = PhysicsSystem2D.instance.raycast(position, this.enemyNode.worldPosition, ERaycast2DType.All, PhysicsController.phyWallGroup);
          console.log(result);
          result = PhysicsSystem2D.instance.raycast(this.enemyNode.worldPosition, position, ERaycast2DType.All, PhysicsController.phyWallGroup);
          console.log(result);
        }

      }, _class3.phyWallGroup = 1 << 2, _class3), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "enemyNode", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "mainCamera", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=e1359f061d662c4ce3873d46c4fe4a101bc3fc37.js.map